package core

import (
	"git.urbach.dev/cli/q/src/asm"
	"git.urbach.dev/cli/q/src/expression"
)

// MultiDefine defines multiple variables at once.
func (f *Function) MultiDefine(left *expression.Expression, right *expression.Expression) error {
	count := 0
	types, err := f.CompileCall(right)

	if err != nil {
		return err
	}

	return left.EachLeaf(func(leaf *expression.Expression) error {
		variable, err := f.Define(leaf)

		if err != nil {
			return err
		}

		if count < len(types) {
			variable.Value.Typ = types[count]
		}

		f.RegisterRegister(asm.MOVE, variable.Value.Register, f.CPU.Output[count])
		f.AddVariable(variable)
		count++
		return nil
	})
}
